MODULE Example1;

FROM Xlib IMPORT DisplayPtr, Window,
		XOpenDisplay, XDefaultScreen, XWhitePixel, XBlackPixel,
		(* DefaultScreenOfDisplay, BlackPixelOfScreen, *)
		XCreateSimpleWindow, XDefaultRootWindow,
		XMapRaised, XMapWindow,
		XFlush;
FROM InOut IMPORT WriteString, WriteHex, WriteLn;
FROM UxProcesses IMPORT Sleep;
FROM SYSTEM IMPORT CAST;

VAR
mydisplay : DisplayPtr;
mywindow : Window;
myscreen : INTEGER;
(* myScreenStruct : Screen; *)
myforeground, mybackground : CARDINAL ;
discard : CARDINAL;

BEGIN
(* Connect to the server: *)
	mydisplay := XOpenDisplay("");
	IF mydisplay = NIL THEN
		WriteString ("Cannot connect to server");
		WriteLn;
		HALT;
	END;
WriteString ("mydisplay: "); WriteHex (CAST(CARDINAL, mydisplay), 8);
WriteLn;
(* Get a screen: *)
	myscreen := XDefaultScreen(mydisplay);
	(* myScreenStruct := DefaultScreenOfDisplay(mydisplay); *)
WriteString ("myscreen: "); WriteHex (CAST(CARDINAL, myscreen), 8);
WriteLn;
(* Look up "black" and "white": *)
	mybackground := XWhitePixel(mydisplay, myscreen);
(*	myforeground := BlackPixelOfScreen(myScreenStruct); *)
	myforeground := XBlackPixel(mydisplay, myscreen);
(* Create a window at (700,50), width 150, height 100: *)
	mywindow := XCreateSimpleWindow(mydisplay,
		XDefaultRootWindow(mydisplay), 700, 50, 150, 100, 2,
		myforeground, mybackground);
(* Pop this window up on the screen: *)
	(* XMapRaised *) XMapWindow(mydisplay, mywindow);
(* Flush the request queue then pause for 10 seconds: *)
	XFlush(mydisplay);
	discard := Sleep(10);
END Example1.
